internal::function_output< Output > Class Template Reference

Implements methods for both executable and function nodes that puts Output to its successors. More...

`#include <_flow_graph_node_impl.h>`

Inheritance diagram for internal::function_output< Output >:
Collaboration diagram for internal::function_output< Output >:

## Public Types

typedef Output | output_type
typedef sender< output_type >::successor_type | successor_type
typedef broadcast_cache< output_type > | broadcast_cache_type
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

| function_output (graph &g)
| function_output (const function_output &other)
bool | register_successor (successor_type &r) __TBB_override
| Adds a new successor to this node. More...
bool | remove_successor (successor_type &r) __TBB_override
| Removes a successor from this node. More...
task * | try_put_task (const output_type &i)
broadcast_cache_type & | successors ()
graph & | graph_reference () const
Public Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get (Output &)
| Request an item from the sender. More...
virtual bool | try_reserve (Output &)
| Reserves an item in the sender. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()
virtual bool | try_release ()
| Releases the reserved item. More...
virtual bool | try_consume ()
| Consumes the reserved item. More...

## Protected Attributes

broadcast_cache_type | my_successors
graph & | my_graph_ref

## Friends

template<int N>
struct | clear_element

## Additional Inherited Members

Public Attributes inherited from tbb::flow::interface11::sender< Output >
__TBB_DEPRECATED typedef Output | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< Output >::filtered_type | filtered_type
Protected Member Functions inherited from tbb::flow::interface11::sender< Output >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Detailed Description

### template<typename Output>
class internal::function_output< Output >

Implements methods for both executable and function nodes that puts Output to its successors.

Definition at line 854 of file _flow_graph_node_impl.h.

## Member Typedef Documentation

## broadcast_cache_type

template<typename Output >

typedef broadcast_cache<output_type> internal::function_output< Output >::broadcast_cache_type

Definition at line 860 of file _flow_graph_node_impl.h.

## output_type

template<typename Output >

typedef Output internal::function_output< Output >::output_type

Definition at line 858 of file _flow_graph_node_impl.h.

## successor_type

template<typename Output >

typedef sender<output_type>::successor_type internal::function_output< Output >::successor_type

Definition at line 859 of file _flow_graph_node_impl.h.

## Constructor & Destructor Documentation

## function_output() [1/2]

template<typename Output >

internal::function_output< Output >::function_output | ( | graph & | g | ) |

inline

Definition at line 866 of file _flow_graph_node_impl.h.

: my_graph_ref(g) { my_successors.set_owner(this); }

References internal::function_output< Output >::my_successors, and internal::successor_cache< T, M >::set_owner().

Here is the call graph for this function:

## function_output() [2/2]

template<typename Output >

internal::function_output< Output >::function_output | ( | const function_output< Output > & | other | ) |

inline

Definition at line 867 of file _flow_graph_node_impl.h.

: sender<output_type>(), my_graph_ref(other.my_graph_ref) {
my_successors.set_owner(this);
}

References internal::function_output< Output >::my_successors, and internal::successor_cache< T, M >::set_owner().

Here is the call graph for this function:

## Member Function Documentation

## graph_reference()

template<typename Output >

graph& internal::function_output< Output >::graph_reference | ( |  | ) | const

inline

Definition at line 918 of file _flow_graph_node_impl.h.

{ return my_graph_ref; }

References internal::function_output< Output >::my_graph_ref.

## register_successor()

template<typename Output >

bool internal::function_output< Output >::register_successor | ( | successor_type & | r | ) |

inline virtual

Adds a new successor to this node.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 872 of file _flow_graph_node_impl.h.

{
successors().register_successor( r );
return true;
}

References internal::successor_cache< T, M >::register_successor(), and internal::function_output< Output >::successors().

Here is the call graph for this function:

## remove_successor()

template<typename Output >

bool internal::function_output< Output >::remove_successor | ( | successor_type & | r | ) |

inline virtual

Removes a successor from this node.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 878 of file _flow_graph_node_impl.h.

{
successors().remove_successor( r );
return true;
}

References internal::successor_cache< T, M >::remove_successor(), and internal::function_output< Output >::successors().

Here is the call graph for this function:

## successors()

template<typename Output >

broadcast_cache_type& internal::function_output< Output >::successors | ( |  | ) |

inline

Definition at line 916 of file _flow_graph_node_impl.h.

{ return my_successors; }

References internal::function_output< Output >::my_successors.

Referenced by internal::function_output< Output >::register_successor(), internal::function_output< Output >::remove_successor(), and tbb::flow::interface11::async_node< Input, Output, Policy, Allocator >::try_put_impl().

Here is the caller graph for this function:

## try_put_task()

template<typename Output >

task* internal::function_output< Output >::try_put_task | ( | const output_type & | i | ) |

inline

Definition at line 912 of file _flow_graph_node_impl.h.

{ // not a virtual method in this class
return my_successors.try_put_task(i);
}

References internal::function_output< Output >::my_successors, and internal::broadcast_cache< T, M >::try_put_task().

Here is the call graph for this function:

## Friends And Related Function Documentation

## clear_element

template<typename Output >
template<int N>

friend struct clear_element

friend

Definition at line 857 of file _flow_graph_node_impl.h.

## Member Data Documentation

## my_graph_ref

template<typename Output >

graph& internal::function_output< Output >::my_graph_ref

protected

Definition at line 921 of file _flow_graph_node_impl.h.

Referenced by internal::function_output< Output >::graph_reference().

## my_successors

template<typename Output >

broadcast_cache_type internal::function_output< Output >::my_successors

protected

Definition at line 920 of file _flow_graph_node_impl.h.

Referenced by internal::function_output< Output >::function_output(), internal::multifunction_output< Output >::multifunction_output(), internal::function_output< Output >::successors(), tbb::flow::interface11::function_node< Input, Output, Policy, Allocator >::successors(), tbb::flow::interface11::continue_node< Output, Policy >::successors(), internal::function_output< Output >::try_put_task(), and internal::multifunction_output< Output >::try_put_task().

The documentation for this class was generated from the following file:

- _flow_graph_node_impl.h

internal::successor_cache::set_owner
void set_owner(owner_type *owner)
Definition: _flow_graph_cache_impl.h:326
internal::successor_cache::remove_successor
void remove_successor(successor_type &r)
Definition: _flow_graph_cache_impl.h:335
internal::successor_cache::register_successor
void register_successor(successor_type &r)
Definition: _flow_graph_cache_impl.h:330
internal::function_output::successors
broadcast_cache_type & successors()
Definition: _flow_graph_node_impl.h:916
internal::broadcast_cache::try_put_task
task * try_put_task(const T &t) __TBB_override
Definition: _flow_graph_cache_impl.h:478
internal::function_output::my_successors
broadcast_cache_type my_successors
Definition: _flow_graph_node_impl.h:920
internal::function_output::my_graph_ref
graph & my_graph_ref
Definition: _flow_graph_node_impl.h:921

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.